﻿
Imports System.Net
Imports System.IO
Imports System.Text
Imports System.Web.Script.Serialization

Public Class API

    ''' <summary>
    ''' Send Array 
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <param name="RecipientNumber">Send SMS to this numbers</param>
    ''' <param name="Message">Text of your SMS</param>
    ''' <param name="SpecialNumber">Your Special number ,send sms from this number</param>
    ''' <param name="IsFlash">True/False</param>
    ''' <param name="CheckingMessageID">Your local ID for message</param>
    ''' <returns>MessageID for each SMS</returns>
    Public Shared Function SendArray(WSID As Integer, UserName As String, Password As String, Domain As String, RecipientNumber As String(), Message As String, _
        SpecialNumber As String, IsFlash As Boolean, CheckingMessageID As Long()) As Long()
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.SendArray(WSID, UserName, Password, Domain, RecipientNumber, Message, _
                SpecialNumber, IsFlash, CheckingMessageID)
        End Using
    End Function

    ''' <summary>
    ''' Send Array Schedule
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <param name="RecipientNumber">Send SMS to this numbers</param>
    ''' <param name="Message">Text of your SMS</param>
    ''' <param name="SpecialNumber"></param>
    ''' <param name="IsFlash">True/False</param>
    ''' <param name="Year">int</param>
    ''' <param name="Month">int</param>
    ''' <param name="Day">int</param>
    ''' <param name="Hour">int</param>
    ''' <param name="Minute">int</param>
    ''' <returns>MessageID</returns>
    Public Shared Function SendArraySchedule(WSID As Integer, UserName As String, Password As String, Domain As String, RecipientNumber As String(), Message As String, _
        SpecialNumber As String, IsFlash As Boolean, Year As Integer, Month As Integer, Day As Integer, Hour As Integer, _
        Minute As Integer) As Long
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.SendArraySchedule(WSID, UserName, Password, Domain, RecipientNumber, Message, _
                SpecialNumber, IsFlash, Year, Month, Day, Hour, _
                Minute)
        End Using
    End Function

    ''' <summary>
    ''' Get Message ID
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <param name="CheckingMessageID">Your local ID for message</param>
    ''' <returns>MessageIDs</returns>
    Public Shared Function GetMessageID(WSID As Integer, UserName As String, Password As String, Domain As String, CheckingMessageID As Long()) As Long()
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.GetMessageID(WSID, UserName, Password, Domain, CheckingMessageID)
        End Using
    End Function


    ''' <summary>
    ''' Get Message Status
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <param name="MessageID">long[] MessageIDs</param>
    ''' <returns></returns>
    Public Shared Function GetMessageStatus(WSID As Integer, UserName As String, Password As String, Domain As String, MessageID As Long()) As Long()
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.GetMessageStatus(WSID, UserName, Password, Domain, MessageID)
        End Using
    End Function

    ''' <summary>
    ''' Get Number Group Data
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <returns>NumberGroupItem</returns>
    Public Shared Function GetNumberGroupData(WSID As Integer, UserName As String, Password As String, Domain As String) As SoapWebService.NumberGroupItem()
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.GetNumberGroupData(WSID, UserName, Password, Domain)
        End Using
    End Function

    ''' <summary>
    ''' Send To Group Number
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <param name="NumberGroupID">long[] GroupIDs</param>
    ''' <param name="Message">Text of your SMS</param>
    ''' <param name="SpecialNumber">Your Special number ,send sms from this number</param>
    ''' <param name="IsFlash">True/False</param>
    ''' <param name="DontSendToRepeatedNumber">True/False</param>
    ''' <returns>SendID for Send To Group</returns>
    Public Shared Function SendNumberGroup(WSID As Integer, UserName As String, Password As String, Domain As String, NumberGroupID As Long(), Message As String, _
        SpecialNumber As String, IsFlash As Boolean, DontSendToRepeatedNumber As Boolean) As Long
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.SendNumberGroup(WSID, UserName, Password, Domain, NumberGroupID, Message, _
                SpecialNumber, IsFlash, DontSendToRepeatedNumber)
        End Using
    End Function

    ''' <summary>
    ''' Send Number Group Schedule
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <param name="NumberGroupID">long[] GroupIDs</param>
    ''' <param name="Message">Text of your SMS</param>
    ''' <param name="SpecialNumber">Your Special number ,send sms from this number</param>
    ''' <param name="IsFlash">True/False</param>
    ''' <param name="DontSendToRepeatedNumber">True/False</param>
    ''' <param name="Year">int</param>
    ''' <param name="Month">int</param>
    ''' <param name="Day">int</param>
    ''' <param name="Hour">int</param>
    ''' <param name="Minute">int</param>
    ''' <returns>SendID for Send To Group</returns>
    Public Shared Function SendNumberGroupSchedule(WSID As Integer, UserName As String, Password As String, Domain As String, NumberGroupID As Long(), Message As String, _
        SpecialNumber As String, IsFlash As Boolean, DontSendToRepeatedNumber As Boolean, Year As Integer, Month As Integer, Day As Integer, _
        Hour As Integer, Minute As Integer) As Long
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.SendNumberGroupSchedule(WSID, UserName, Password, Domain, NumberGroupID, Message, _
                SpecialNumber, IsFlash, DontSendToRepeatedNumber, Year, Month, Day, _
                Hour, Minute)
        End Using
    End Function

    ''' <summary>
    ''' Insert Number To PhoneBook
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <param name="NumberGroupID">long GroupID</param>
    ''' <param name="PersonNumber">Array of String </param>
    ''' <param name="PersonName">Array of String </param>
    ''' <returns>Array of long </returns>
    Public Shared Function InsertNumberInNumberGroup(WSID As Integer, UserName As String, Password As String, Domain As String, NumberGroupID As Long, PersonNumber As String(), _
        PersonName As String()) As Long()
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.InsertNumberInNumberGroup(WSID, UserName, Password, Domain, NumberGroupID, PersonNumber, _
                PersonName)
        End Using
    End Function

    ''' <summary>
    ''' Get Inbox Message
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <param name="NumberOfMessage">Int Number of message</param>
    ''' <returns>InboxItem</returns>
    Public Shared Function GetInboxMessage(WSID As Integer, UserName As String, Password As String, Domain As String, NumberOfMessage As Integer) As SoapWebService.InboxItem()
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.GetInboxMessage(WSID, UserName, Password, Domain, NumberOfMessage)
        End Using
    End Function

    ''' <summary>
    ''' Get Inbox Message With SpecialNumber
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <param name="NumberOfMessage">Int Number of message</param>
    ''' <param name="SpecialNumber">Your Special number ,send sms from this number</param>
    ''' <returns>InboxItem</returns>
    Public Shared Function GetInboxMessageWithNumber(WSID As Integer, UserName As String, Password As String, Domain As String, NumberOfMessage As Integer, SpecialNumber As String) As SoapWebService.InboxItem()
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.GetInboxMessageWithNumber(WSID, UserName, Password, Domain, NumberOfMessage, SpecialNumber)
        End Using
    End Function

    ''' <summary>
    ''' Get Inbox Message With Last InboxID
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <param name="NumberOfMessage">int</param>
    ''' <param name="InboxID">int</param>
    ''' <param name="IsReaded">True/False</param>
    ''' <returns>ResultInbox</returns>
    Public Shared Function GetInboxMessageWithInboxID(WSID As Integer, UserName As String, Password As String, Domain As String, NumberOfMessage As Integer, InboxID As Integer, _
        IsReaded As Boolean) As SoapWebService.ResultInbox
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.GetInboxMessageWithInboxID(WSID, UserName, Password, Domain, NumberOfMessage, InboxID, _
                IsReaded)
        End Using
    End Function

    ''' <summary>
    ''' Get Account Credit
    ''' </summary>
    ''' <param name="WSID">int</param>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <param name="Domain">String</param>
    ''' <returns>long Credit</returns>
    Public Shared Function GetCredit(WSID As Integer, UserName As String, Password As String, Domain As String) As Long
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.GetCredit(WSID, UserName, Password, Domain)
        End Using
    End Function

    ''' <summary>
    ''' Get User Info
    ''' </summary>
    ''' <param name="UserName">String</param>
    ''' <param name="Password">String</param>
    ''' <returns>ProfileInfo</returns>
    Public Shared Function GetUserInfo(WSID As Integer, UserName As String, Password As String, Domain As String) As SoapWebService.ProfileInfo
        Using SMSService As New SoapWebService.SOAPWebService()
            Return SMSService.GetUserInfo(WSID, UserName, Password, Domain)
        End Using
    End Function
End Class

